/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.spa.commons.utils.MapUtils
 *  com.deepexi.spa.commons.utils.StringUtils
 *  com.deepoove.poi.data.CellRenderData
 *  com.deepoove.poi.data.RowRenderData
 *  com.deepoove.poi.data.style.Style
 *  com.deepoove.poi.util.StyleUtils
 *  org.apache.poi.xwpf.usermodel.IBody
 *  org.apache.poi.xwpf.usermodel.XWPFParagraph
 *  org.apache.poi.xwpf.usermodel.XWPFRun
 *  org.apache.poi.xwpf.usermodel.XWPFTable
 *  org.apache.poi.xwpf.usermodel.XWPFTableCell
 *  org.apache.poi.xwpf.usermodel.XWPFTableRow
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.CTRow
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.CTRow$Factory
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTbl
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTcPr
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.CTVMerge
 *  org.openxmlformats.schemas.wordprocessingml.x2006.main.STMerge
 *  org.springframework.util.CollectionUtils
 */
package com.deepexi.scd.calculate.util;

import com.deepexi.scd.calculate.util.TableStyle;
import com.deepexi.spa.commons.utils.MapUtils;
import com.deepexi.spa.commons.utils.StringUtils;
import com.deepoove.poi.data.CellRenderData;
import com.deepoove.poi.data.RowRenderData;
import com.deepoove.poi.data.style.Style;
import com.deepoove.poi.util.StyleUtils;
import java.io.InputStream;
import java.math.BigInteger;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.poi.xwpf.usermodel.IBody;
import org.apache.poi.xwpf.usermodel.XWPFParagraph;
import org.apache.poi.xwpf.usermodel.XWPFRun;
import org.apache.poi.xwpf.usermodel.XWPFTable;
import org.apache.poi.xwpf.usermodel.XWPFTableCell;
import org.apache.poi.xwpf.usermodel.XWPFTableRow;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTRow;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTbl;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTcPr;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTVMerge;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.STMerge;
import org.springframework.util.CollectionUtils;

public class XWPFHelper {
    public static Map<String, Object> getTable(String pattern, List<XWPFTable> tables) {
        HashMap<String, Object> m = new HashMap<String, Object>();
        for (XWPFTable t : tables) {
            if (!t.getText().contains(pattern)) continue;
            m.put("table", t);
            return m;
        }
        return m;
    }

    public static void clearTable(String pattern, List<XWPFTable> tables, XWPFRun run) {
        List rows = null;
        List cells = null;
        for (XWPFTable t : tables) {
            if (!t.getText().contains(pattern)) continue;
            rows = t.getRows();
            for (int i = 2; i < rows.size(); ++i) {
                t.removeRow(i);
            }
            cells = ((XWPFTableRow)rows.get(1)).getTableCells();
            for (XWPFTableCell cell : cells) {
                XWPFParagraph par = (XWPFParagraph)cell.getParagraphs().get(0);
                for (XWPFRun r : par.getRuns()) {
                    r.setText("", 0);
                }
            }
        }
    }

    public static void copyTableCell(XWPFTableCell target, XWPFTableCell source) {
        target.getCTTc().setTcPr(source.getCTTc().getTcPr());
        for (int pos = 0; pos < target.getParagraphs().size(); ++pos) {
            target.removeParagraph(pos);
        }
        for (XWPFParagraph sp : source.getParagraphs()) {
            XWPFParagraph targetP = target.addParagraph();
            XWPFHelper.copyParagraph(targetP, sp);
        }
    }

    public static void copyParagraph(XWPFParagraph target, XWPFParagraph source) {
        target.getCTP().setPPr(source.getCTP().getPPr());
        for (int pos = 0; pos < target.getRuns().size(); ++pos) {
            target.removeRun(pos);
        }
    }

    public static void copytTableRow(XWPFTableRow target, XWPFTableRow source) {
        target.getCtRow().setTrPr(source.getCtRow().getTrPr());
        for (int i = 0; i < target.getTableCells().size(); ++i) {
            XWPFHelper.copyTableCell(target.getCell(i), source.getCell(i));
        }
    }

    public static XWPFRun getRun(XWPFTableCell cell, XWPFRun source) {
        XWPFParagraph par = (XWPFParagraph)cell.getParagraphs().get(0);
        XWPFRun r = par.createRun();
        r.getCTR().setRPr(source.getCTR().getRPr());
        r.setFontFamily(source.getFontFamily());
        r.setFontSize(source.getFontSize());
        par.removeRun(source.getTextPosition());
        return r;
    }

    public static XWPFTable getTableByTBL(List<XWPFTable> tables, CTTbl tbl) {
        for (int i = 0; i < tables.size(); ++i) {
            if (tables.get(i).getCTTbl() != tbl) continue;
            return tables.get(i);
        }
        return null;
    }

    public static void insertRow(XWPFTable table, int copyrowIndex, int newrowIndex) {
        XWPFTableRow targetRow = table.insertNewTableRow(newrowIndex);
        XWPFTableRow copyRow = table.getRow(copyrowIndex);
        XWPFHelper.createCellsAndCopyStyles(targetRow, copyRow);
    }

    public static void createCellsAndCopyStyles(XWPFTableRow targetRow, XWPFTableRow sourceRow) {
        targetRow.getCtRow().setTrPr(sourceRow.getCtRow().getTrPr());
        List tableCells = sourceRow.getTableCells();
        if (CollectionUtils.isEmpty((Collection)tableCells)) {
            return;
        }
        for (XWPFTableCell sourceCell : tableCells) {
            XWPFRun run;
            XWPFParagraph p;
            XWPFTableCell newCell = targetRow.addNewTableCell();
            newCell.getCTTc().setTcPr(sourceCell.getCTTc().getTcPr());
            List sourceParagraphs = sourceCell.getParagraphs();
            if (CollectionUtils.isEmpty((Collection)sourceParagraphs)) continue;
            XWPFParagraph sourceParagraph = (XWPFParagraph)sourceParagraphs.get(0);
            List targetParagraphs = newCell.getParagraphs();
            if (CollectionUtils.isEmpty((Collection)targetParagraphs)) {
                p = newCell.addParagraph();
                p.getCTP().setPPr(sourceParagraph.getCTP().getPPr());
                run = p.getRuns().isEmpty() ? p.createRun() : (XWPFRun)p.getRuns().get(0);
                run.setFontFamily(((XWPFRun)sourceParagraph.getRuns().get(0)).getFontFamily());
                continue;
            }
            p = (XWPFParagraph)targetParagraphs.get(0);
            p.getCTP().setPPr(sourceParagraph.getCTP().getPPr());
            XWPFRun xWPFRun = run = p.getRuns().isEmpty() ? p.createRun() : (XWPFRun)p.getRuns().get(0);
            if (sourceParagraph.getRuns().size() <= 0) continue;
            run.setFontFamily(((XWPFRun)sourceParagraph.getRuns().get(0)).getFontFamily());
        }
    }

    public static void replaceContent(XWPFTable table, int listsStartRow, List<RowRenderData> dataList, Map<String, String> crewNameMap) {
        if (CollectionUtils.isEmpty(dataList)) {
            return;
        }
        List rows = table.getRows();
        block0: for (int i = listsStartRow; i < rows.size(); ++i) {
            XWPFTableRow row = table.getRow(i);
            List cells = row.getTableCells();
            if (CollectionUtils.isEmpty((Collection)cells)) continue;
            int size = cells.size();
            for (int j = 0; j < size; ++j) {
                XWPFTableCell cell = (XWPFTableCell)cells.get(j);
                String text = ((CellRenderData)dataList.get(i - listsStartRow).getCells().get(j)).getCellText() + "";
                if (j != 0 || !StringUtils.isNotBlank((CharSequence)text) || CollectionUtils.isEmpty((Collection)cell.getParagraphs())) continue;
                cell.removeParagraph(0);
                XWPFParagraph para = cell.addParagraph();
                para.setSpacingBetween(1.0);
                cell.setText(MapUtils.getString(crewNameMap, (Object)text, (String)""));
                continue block0;
            }
        }
    }

    public static void insertRowOrCopyStyle(XWPFTable table, int copyrowIndex, RowRenderData rowData) {
        if (null == rowData || rowData.size() <= 0) {
            return;
        }
        List cellDatas = rowData.getCells();
        XWPFTableRow row = table.getRow(copyrowIndex);
        CTRow ctrow = null;
        try {
            ctrow = CTRow.Factory.parse((InputStream)row.getCtRow().newInputStream());
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        XWPFTableRow newRow = new XWPFTableRow(ctrow, table);
        List copyCells = newRow.getTableCells();
        for (int i = 0; i < copyCells.size(); ++i) {
            XWPFTableCell cell = (XWPFTableCell)newRow.getTableCells().get(i);
            for (XWPFParagraph p : cell.getParagraphs()) {
                for (XWPFRun r : p.getRuns()) {
                    String cellText = StringUtils.isBlank((CharSequence)((CellRenderData)cellDatas.get(i)).getCellText().getText()) ? "" : ((CellRenderData)cellDatas.get(i)).getCellText().getText();
                    r.setText(cellText, 0);
                }
            }
        }
        table.addRow(newRow, table.getRows().size());
    }

    public static void setTableFontStyle(XWPFTable table, int listsStartRow, List<RowRenderData> dataList) {
        if (CollectionUtils.isEmpty(dataList)) {
            return;
        }
        List rows = table.getRows();
        for (int i = listsStartRow; i < rows.size(); ++i) {
            XWPFTableRow row = table.getRow(i);
            List cells = row.getTableCells();
            if (CollectionUtils.isEmpty((Collection)cells)) continue;
            int size = cells.size();
            for (int j = 0; j < size; ++j) {
                XWPFTableCell cell = (XWPFTableCell)cells.get(j);
                cell.removeParagraph(0);
                XWPFParagraph xwpfParagraph = cell.addParagraph();
                String text = ((CellRenderData)dataList.get(i - listsStartRow).getCells().get(j)).getCellText() + "";
                XWPFRun xwpfRun = xwpfParagraph.createRun();
                StyleUtils.styleRun((XWPFRun)xwpfRun, (Style)TableStyle.setFontStyle());
                xwpfRun.setText(text);
            }
        }
    }

    public static void mergeCellsHorizonal(XWPFTable table, int row, int fromCol, int toCol) {
        if (toCol <= fromCol) {
            return;
        }
        XWPFTableCell cell = table.getRow(row).getCell(fromCol);
        CTTcPr tcPr = XWPFHelper.getTcPr(cell);
        XWPFTableRow rowTable = table.getRow(row);
        for (int colIndex = fromCol + 1; colIndex <= toCol; ++colIndex) {
            rowTable.getCtRow().removeTc(fromCol + 1);
            rowTable.removeCell(fromCol + 1);
        }
        tcPr.addNewGridSpan();
        tcPr.getGridSpan().setVal(BigInteger.valueOf(toCol - fromCol + 1));
    }

    public static void mergeCellsVertically(XWPFTable table, int col, int fromRow, int toRow) {
        if (toRow <= fromRow) {
            return;
        }
        for (int rowIndex = fromRow; rowIndex <= toRow; ++rowIndex) {
            XWPFTableCell cell = table.getRow(rowIndex).getCell(col);
            CTTcPr tcPr = XWPFHelper.getTcPr(cell);
            CTVMerge vMerge = tcPr.addNewVMerge();
            if (rowIndex == fromRow) {
                vMerge.setVal(STMerge.RESTART);
                continue;
            }
            vMerge.setVal(STMerge.CONTINUE);
            cell.removeParagraph(0);
            XWPFParagraph newPara = new XWPFParagraph(cell.getCTTc().addNewP(), (IBody)cell);
            XWPFRun run = newPara.createRun();
            run.setText("");
        }
    }

    private static CTTcPr getTcPr(XWPFTableCell cell) {
        CTTcPr tcPr = cell.getCTTc().isSetTcPr() ? cell.getCTTc().getTcPr() : cell.getCTTc().addNewTcPr();
        return tcPr;
    }
}

